<?php
require_once( "config.class.php" );
class player extends config {
	private $streamid = NULL;

	private function save_streamlist( $streamlist ) {
		if( is_array( $streamlist ) ) {
			$temp = tempnam( $this->ramdrive, 'tmp' );
			foreach( $streamlist as $key => $val ) {
				$line = "$key,";
				$line .= $val['URL'].",";
				$line .= $val['VOB'].",";
				$line .= $val['NAME']."\n";
				file_put_contents( $temp, $line, FILE_APPEND );
			}
			rename( $this->homedir."/streamlist", $this->homedir."/streamlist.old" );
			if( rename( $temp, $this->homedir."/streamlist" ) ) {
				unlink( $this->homedir."/streamlist.old" );
				// renew after saving
				$this->get_streamlist( true );
				return( true );
			} else {
				$this->addError( "Konnte neue Streamlist nicht speichern." );
				return( false );
			}
		} else {
			$this->addError( "\$streamlist ist kein Array!" );
			return( false );
		}
	}

	public function get_current_stream() {
		if( $this->streamid == NULL ) {
			$this->streamid = (int)trim(
				shell_exec( "grep \",`cat ".$this->ramdrive."/current_stream`,\" ".$this->homedir."/streamlist| awk -F, '{print $1}'" )
			);

			if( $this->streamid > 0 AND $this->streamid < 100 ) {
				return( $this->streamid );
			} else {
				$this->addError( "Streamid ist ung&uuml;ltig." );
				return( false );
			}
		} else {
			return( $this->streamid );
		}
	}

	public function get_volume() {
		return( trim(
			shell_exec( 'mpc volume | sed \'s/volume:[ ]\{0,2\}\([0-9]\{1,3\}\)%/\1/\'' )
		) );
	}

	public function mv_stream_down( $ID ) {
		$ID++; // ID erhoehen, da vom JS der Wert eins niedriger kommt
		if( is_int( $ID ) AND $ID > 0 AND $ID < 99 ) {
			$streamlist = $this->get_streamlist();
			$temp = $streamlist[ $ID ];
			$streamlist[ $ID ] = $streamlist[ $ID + 1 ];
			$streamlist[ $ID + 1 ] = $temp;
			return( $this->save_streamlist( $streamlist ) );
		} else {
			$this->addError( "\$ID ist keine Zahl oder zu gro&szlig;/klein." );
			return( false );
		}
	}

	public function mv_stream_up( $ID ) {
		$ID++; // ID erhoehen, da vom JS der Wert eins niedriger kommt
		if( is_int( $ID ) AND $ID > 1 AND $ID < 100 ) {
			$streamlist = $this->get_streamlist();
			$temp = $streamlist[ $ID - 1 ];
			$streamlist[ $ID - 1 ] = $streamlist[ $ID ];
			$streamlist[ $ID ] = $temp;
			return( $this->save_streamlist( $streamlist ) );
		} else {
			$this->addError( "\$ID ist keine Zahl oder zu gro&szlig;/klein." );
			return( false );
		}
	}

	public function delete_stream( $ID ) {
		$ID++; // ID erhoehen, da vom JS der Wert eins niedriger kommt
		if( is_int( $ID ) AND $ID > 0 AND $ID < 100 ) {
			$streamlist = $this->get_streamlist();
			array_splice( $streamlist, ( $ID - 1 ), 1 );
			// Alles um eins verschieben, damit erster Stream bei Index 1 anfaengt.
			array_unshift( $streamlist, "" );
			unset( $streamlist[0] );
			return( $this->save_streamlist( $streamlist ) );
		} else {
			$this->addError( "\$ID ist keine Zahl oder zu gro&szlig;/klein." );
			return( false );
		}
	}

	public function add_stream( $values ) {
		$validation = true;
		if( filter_var( $values['pl_addstr_url'], FILTER_VALIDATE_URL ) === false ) {
			$this->addError( "StreamURL ist keine g&uuml;ltige Adresse" );
			$validation = false;
		}

		if( strlen( $values['pl_addstr_name'] ) < 3 OR strstr( $values['pl_addstr_name'], "," ) ) {
			$this->addError( "Name ist zu kurz oder enth&auml;lt ein Komma." );
			$validation = false;
		}

		if( (int)$values['pl_addstr_nr'] < 0 OR (int)$values['pl_addstr_nr'] > 99 ) {
			$this->addError( "Kann Stream nicht nach #".(int)$values['pl_addstr_nr']." einordnen." );
			$validation = false;
		}

		if( !file_exists( $this->vob_dir."/".$values['pl_addstr_vob'] ) ) {
			$this->addError( "Ansagetext existiert nich." );
			$validation = false;
		}

		if( count( file( $this->homedir."/streamlist" ) ) > 99 ) {
			$this->addError( "Maximale Anzahl von Sendern erreicht." );
			$validation = false;
		}

		if( $validation ) {
			$streamlist = $this->get_streamlist();
			if( (int)$values['pl_addstr_nr'] > count( $streamlist ) ) {
				array_push( $streamlist, array(
					"URL" => $values['pl_addstr_url'],
					"VOB" => $values['pl_addstr_vob'],
					"NAME" => $values['pl_addstr_name']
				) );
			} else {
				$left = array_slice( $streamlist, 0, (int)$values['pl_addstr_nr'] );
				$right = array_slice( $streamlist, (int)$values['pl_addstr_nr'] );
				$insert[ (int)$values['pl_addstr_nr'] + 1 ] = array(
					"URL" => $values['pl_addstr_url'],
					"VOB" => $values['pl_addstr_vob'],
					"NAME" => $values['pl_addstr_name'] );
				$streamlist = array_merge( $left, $insert, $right );
				// Alles um eins verschieben, damit erster Stream bei Index 1 anfaengt
				array_unshift( $streamlist, "" );
				unset( $streamlist[0] );
			}
			return( $this->save_streamlist( $streamlist ) );
		} else {
			return( false );
		}
	}
}
?>
